.\"	$NetBSD: mt.1,v 1.33 2003/08/07 09:05:17 agc Exp $
.\"
.\" Copyright (c) 1981, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)mt.1	8.1 (Berkeley) 6/6/93
.\"
.Dd March 9, 2008
.Dt MT 1
.Os
.Sh NAME
.Nm mt
.Nd magnetic tape manipulation
.Sh SYNOPSIS
.Nm
.Op Fl f Ar tapename
.Ar command
.Op Ar count
.Sh DESCRIPTION
The
.Nm
program is used to give commands to a magnetic tape drive.
By default
.Nm
performs the requested operation once.
Operations may be performed multiple times by specifying
.Ar count  .
.Pp
Note
that
.Ar tapename
must reference a raw (not block) tape device.
If
.Ar tapename
is of the form
.Qq host:tapename ,
or
.Qq user@host:tapename ,
.Nm
writes to the named tape device on the remote host using
.Xr rmt 8 .
.Pp
The
.Xr rmt 8
process on the remote host is typically initiated via
.Xr rsh 1 ,
although an alternate method such as
.Xr ssh 1
can be specified via the
.Ev RCMD_CMD
environment variable.
.Pp
The available commands are listed below.
Only as many characters as are required to uniquely identify a command
need be specified.
.Bl -tag -width "eof, weof"
.It Cm asf
Move forward
.Ar count
files from the beginning of the tape.
This is accomplished by a rewind followed by fsf
.Ar count .
.It Cm eof , weof
Write
.Ar count
end-of-file marks at the current position on the tape.
.It Cm fsf
Forward space
.Ar count
files.
.It Cm fsr
Forward space
.Ar count
records.
.It Cm bsf
Back space
.Ar count
files.
.It Cm bsr
Back space
.Ar count
records.
.It Cm rewind
Rewind the tape.
(The
.Ar count
is ignored.)
.It Cm offline , rewoffl
Rewind the tape and place the tape unit off-line.
Where supported, this ejects the tape.
(The
.Ar count
is ignored.)
.It Cm status
Print status information about the tape unit.
(The
.Ar count
is ignored.)
.It Cm retension
Retensions the tape.
Not all tape drives support this feature.
(The
.Ar count
is ignored.)
.It Cm erase
Erases the tape
Not all tape drives support this feature.
(The
.Ar count
is ignored.)
.It Cm eew
Enable or disable early warning EOM behaviour.
Set
.Ar count
to nonzero to enable, zero to disable.
.It Cm eom
Forward space to the end of recorded media.
(The
.Ar count
is ignored.)
.It Cm blocksize , setblk
Set the tape blocksize to
.Ar count
bytes.
A
.Ar count
of zero sets variable blocksize.
.It Cm density , setdensity
Set the tape density code to
.Ar count
as specified in the
.Tn SCSI-3
specification.
See the
.Sx DENSITY CODES
section for a list of codes for commonly used media types.
.It Cm rdspos
Read the logical block position of the tape.
Not all tape drives support this feature.
(The
.Ar count
is ignored.)
.It Cm rdhpos
Read the hardware block position of the tape.
Not all tape drives support this feature.
(The
.Ar count
is ignored.)
.It Cm setspos
Set the logical block position of the tape to
.Ar count.
Not all tape drives support this feature.
.It Cm sethpos
Set the hardware block position of the tape to
.Ar count.
Not all tape drives support this feature.
.It Cm compress
If
.Ar count
is zero, disable compression.
Otherwise enable compression.
Not all tape drives support this feature.
.El
.Pp
If a tape name is not specified, and the environment variable
.Ev TAPE
is not set, then
.Nm
uses the device
.Pa /dev/nrst0 .
.Sh EXIT STATUS
.Nm
returns a 0 exit status when the operation(s) were successful,
1 if the command was unrecognized, and 2 if an operation failed.
.Sh DENSITY CODES
The SCSI-3 specification defines a number of density codes for
various tape media, some of which are listed here.
Note that many tape drive vendors also define model-specific codes.
.Pp
.Bl -column "Code" "Format" -compact
.It Em "Code	Format"
.It Li 0 Ta Device default
.It Li 1 Ta 1/2" 800 bpi
.It Li 2 Ta 1/2" 1600 bpi
.It Li 3 Ta 1/2" 6250 bpi
.It Li 4 Ta QIC-11
.It Li 5 Ta QIC-24
.It Li 15 Ta QIC-120
.It Li 16 Ta QIC-150
.It Li 17 Ta QIC-320/525
.It Li 18 Ta QIC-1320/1350
.It Li 19 Ta DDS
.It Li 28 Ta QIC-385M
.It Li 29 Ta QIC-410M
.It Li 30 Ta QIC-1000C
.It Li 31 Ta QIC-2100C
.It Li 32 Ta QIC-6GB
.It Li 33 Ta QIC-20GB
.It Li 34 Ta QIC-2GB
.It Li 35 Ta QIC-875M
.It Li 36 Ta DDS-2
.It Li 37 Ta DDS-3
.It Li 38 Ta DDS-4
.El
.Sh ENVIRONMENT
If the following environment variables exist, they are used by
.Nm .
.Bl -tag -width Fl
.It Ev TAPE
.Nm
uses device filename given in the
.Ev TAPE
environment variable if the
.Ar tapename
argument is not given.
.It Ev RCMD_CMD
.Nm
will use
.Ev RCMD_CMD
rather than
.Pa /usr/bin/rsh
to invoke
.Xr rmt 8
on a remote machine.
The full path name must be specified.
.El
.Sh FILES
.Bl -tag -width /dev/rst* -compact
.It Pa /dev/rst*
Raw
.Tn SCSI
tape device
.It Pa /dev/rmt*
Raw magnetic tape device
.El
.Sh SEE ALSO
.Xr dd 1 ,
.Xr ioctl 2 ,
.Xr mtio 4 ,
.Xr st 4 ,
.Xr environ 7
.Sh HISTORY
The
.Nm
utility appeared in
.Bx 4.3 .
